searchData={"items":[{"type":"module","title":"Burrito","doc":"","ref":"Burrito.html"},{"type":"function","title":"Burrito.register_erts_resolver/1","doc":"","ref":"Burrito.html#register_erts_resolver/1"},{"type":"function","title":"Burrito.wrap/1","doc":"","ref":"Burrito.html#wrap/1"},{"type":"module","title":"Burrito.Builder","doc":"Burrito builds in \"phases\". Each phase contains any number of \"steps\" which are executed one after another.\n\nThere are 3 phases:\n\n`:fetch` - This phase is responsible for downloading or copying in any replacement ERTS builds for cross-build targets.\n`:patch` - The patch phase injects custom scripts into the build directory, this phase is also where any custom files should be copied into the build directory before being archived.\n`:build` - This is the final phase in the build flow, it produces the final wrapper binary with a payload embedded inside.\n\nYou can add your own steps before and after phases execute. Your custom steps will also receive the build context struct, and can return a modified one to customize a build to your liking.\n\nAn example of adding a step before the fetch phase, and after the build phase:\n\n```\n# ... mix.exs file\ndef releases do\n  [\n    my_app: [\n      steps: [:assemble, &Burrito.wrap/1],\n      burrito: [\n        # ... other Burrito configuration\n        extra_steps: [\n          fetch: [pre: [MyCustomStepModule, AnotherCustomStepModule]],\n          build: [post: [CustomStepAgain, YetAnotherCustomStepModule]]\n          # ...\n        ]\n      ]\n    ]\n  ]\nend\n# ...\n```","ref":"Burrito.Builder.html"},{"type":"function","title":"Burrito.Builder.build/1","doc":"","ref":"Burrito.Builder.html#build/1"},{"type":"function","title":"Burrito.Builder.raise_invalid_target/1","doc":"","ref":"Burrito.Builder.html#raise_invalid_target/1"},{"type":"module","title":"Burrito.Builder.Context","doc":"","ref":"Burrito.Builder.Context.html"},{"type":"type","title":"Burrito.Builder.Context.erts_location/0","doc":"","ref":"Burrito.Builder.Context.html#t:erts_location/0"},{"type":"type","title":"Burrito.Builder.Context.t/0","doc":"","ref":"Burrito.Builder.Context.html#t:t/0"},{"type":"module","title":"Burrito.Builder.Log","doc":"","ref":"Burrito.Builder.Log.html"},{"type":"function","title":"Burrito.Builder.Log.error/2","doc":"","ref":"Burrito.Builder.Log.html#error/2"},{"type":"function","title":"Burrito.Builder.Log.info/2","doc":"","ref":"Burrito.Builder.Log.html#info/2"},{"type":"function","title":"Burrito.Builder.Log.success/2","doc":"","ref":"Burrito.Builder.Log.html#success/2"},{"type":"function","title":"Burrito.Builder.Log.warning/2","doc":"","ref":"Burrito.Builder.Log.html#warning/2"},{"type":"behaviour","title":"Burrito.Builder.Step","doc":"","ref":"Burrito.Builder.Step.html"},{"type":"callback","title":"Burrito.Builder.Step.execute/1","doc":"This function is called when the step is to be executed by the build phase.\nIt should return a context to be passed along to the next build step or phase.","ref":"Burrito.Builder.Step.html#c:execute/1"},{"type":"module","title":"Burrito.Builder.Target","doc":"","ref":"Burrito.Builder.Target.html"},{"type":"function","title":"Burrito.Builder.Target.init_target/2","doc":"","ref":"Burrito.Builder.Target.html#init_target/2"},{"type":"function","title":"Burrito.Builder.Target.make_triplet/1","doc":"","ref":"Burrito.Builder.Target.html#make_triplet/1"},{"type":"type","title":"Burrito.Builder.Target.erts_source/0","doc":"","ref":"Burrito.Builder.Target.html#t:erts_source/0"},{"type":"type","title":"Burrito.Builder.Target.t/0","doc":"","ref":"Burrito.Builder.Target.html#t:t/0"},{"type":"module","title":"Burrito.Steps.Build.CopyRelease","doc":"","ref":"Burrito.Steps.Build.CopyRelease.html"},{"type":"module","title":"Burrito.Steps.Build.PackAndBuild","doc":"","ref":"Burrito.Steps.Build.PackAndBuild.html"},{"type":"module","title":"Burrito.Steps.Fetch.FetchMusl","doc":"","ref":"Burrito.Steps.Fetch.FetchMusl.html"},{"type":"module","title":"Burrito.Steps.Fetch.Init","doc":"","ref":"Burrito.Steps.Fetch.Init.html"},{"type":"module","title":"Burrito.Steps.Fetch.ResolveERTS","doc":"","ref":"Burrito.Steps.Fetch.ResolveERTS.html"},{"type":"module","title":"Burrito.Steps.Patch.CopyERTS","doc":"This step copies the new ERTS bins into the release, as well as replaces built-in NIFs.","ref":"Burrito.Steps.Patch.CopyERTS.html"},{"type":"module","title":"Burrito.Steps.Patch.RecompileNIFs","doc":"","ref":"Burrito.Steps.Patch.RecompileNIFs.html"},{"type":"function","title":"Burrito.Steps.Patch.RecompileNIFs.nif_sniff/0","doc":"","ref":"Burrito.Steps.Patch.RecompileNIFs.html#nif_sniff/0"},{"type":"module","title":"Burrito.Util","doc":"","ref":"Burrito.Util.html"},{"type":"function","title":"Burrito.Util.get_current_cpu/0","doc":"","ref":"Burrito.Util.html#get_current_cpu/0"},{"type":"function","title":"Burrito.Util.get_current_os/0","doc":"","ref":"Burrito.Util.html#get_current_os/0"},{"type":"function","title":"Burrito.Util.get_otp_version/0","doc":"","ref":"Burrito.Util.html#get_otp_version/0"},{"type":"module","title":"Burrito.Util.Args","doc":"This module provides a method to help fetch CLI arguments passed down\nfrom the Zig wrapper binary.","ref":"Burrito.Util.Args.html"},{"type":"function","title":"Burrito.Util.Args.get_arguments/0","doc":"","ref":"Burrito.Util.Args.html#get_arguments/0"},{"type":"module","title":"Burrito.Util.DefaultERTSResolver","doc":"","ref":"Burrito.Util.DefaultERTSResolver.html"},{"type":"behaviour","title":"Burrito.Util.ERTSResolver","doc":"A module that implements the ERTSResolver behaviour is responsible for returning a target with\na fully resolved `:erts_source` field.\n\nYou can register your ERTS resolver as the default one by calling `Burrito.register_erts_resolver/1`,\notherwise Burrito will use the `Burrito.Util.DefaultERTSResolver` module.","ref":"Burrito.Util.ERTSResolver.html"},{"type":"callback","title":"Burrito.Util.ERTSResolver.do_resolve/1","doc":"","ref":"Burrito.Util.ERTSResolver.html#c:do_resolve/1"},{"type":"function","title":"Burrito.Util.ERTSResolver.resolve/1","doc":"","ref":"Burrito.Util.ERTSResolver.html#resolve/1"},{"type":"module","title":"Burrito.Util.ERTSUniversalMachineFetcher","doc":"","ref":"Burrito.Util.ERTSUniversalMachineFetcher.html"},{"type":"function","title":"Burrito.Util.ERTSUniversalMachineFetcher.fetch_version/4","doc":"","ref":"Burrito.Util.ERTSUniversalMachineFetcher.html#fetch_version/4"},{"type":"module","title":"Burrito.Util.FileCache","doc":"","ref":"Burrito.Util.FileCache.html"},{"type":"function","title":"Burrito.Util.FileCache.clear_cache/0","doc":"","ref":"Burrito.Util.FileCache.html#clear_cache/0"},{"type":"function","title":"Burrito.Util.FileCache.fetch/1","doc":"","ref":"Burrito.Util.FileCache.html#fetch/1"},{"type":"function","title":"Burrito.Util.FileCache.put_if_not_exist/2","doc":"","ref":"Burrito.Util.FileCache.html#put_if_not_exist/2"},{"type":"module","title":"Burrito.Versions.ReleaseFile","doc":"This module provides some helpful functions for requesting, parsing and sorting release files.\nA release file is a simplistic JSON format that contains the releases of an app, where to fetch them, and some release notes.\n(And any other information you want to store in there!)\n\nExample Release File:\n\n```json\n{\n  \"app_name\": \"example_cli_app\",\n  \"releases\": [\n    {\n      \"version\": \"0.2.0\",\n      \"notes\": \"This new version is new and exciting, we promise!\",\n      \"urls\": {\n        \"win64\": \"https://example.com/releases/0.2.0/example_cli_app_win64.exe\",\n        \"darwin\": \"https://example.com/releases/0.2.0/example_cli_app_linux\",\n        \"linux\": \"https://example.com/releases/0.2.0/example_cli_app_darwin\"\n      }\n    },\n    {\n      \"version\": \"0.1.5\",\n      \"notes\": \"This new version is new and exciting, we promise!\",\n      \"urls\": {\n        \"win64\": \"https://example.com/releases/0.1.5/example_cli_app_win64.exe\",\n        \"darwin\": \"https://example.com/releases/0.1.5/example_cli_app_linux\",\n        \"linux\": \"https://example.com/releases/0.1.5/example_cli_app_darwin\"\n      }\n    }\n  ]\n}\n```\n\nThe only required parts of a release JSON file is:\n  * `\"app_name\"` and `\"releases\"` keys must be present at the top-level object\n  * `\"releases\"` must be a list of objects that have a `\"version\"` key that contains a semver string\n\nHere's the minimal JSON Schema for a release file:\n\n```json\n{\n  \"$schema\": \"http://json-schema.org/draft-07/schema\",\n  \"required\": [\n    \"app_name\",\n    \"releases\"\n  ],\n  \"type\": \"object\",\n  \"properties\": {\n    \"app_name\": {\n      \"type\": \"string\"\n    },\n    \"releases\": {\n      \"type\": \"array\",\n      \"additionalItems\": true,\n      \"items\": {\n        \"anyOf\": [\n          {\n            \"default\": {},\n            \"required\": [\n              \"version\"\n            ],\n            \"type\": \"object\",\n            \"properties\": {\n              \"version\": {\n                \"title\": \"The version schema\",\n                \"type\": \"string\"\n              }\n            },\n            \"additionalProperties\": true\n          }\n        ]\n      }\n    }\n  },\n  \"additionalProperties\": true\n}\n```\n\nYou can customize everything else to your liking!\n\nTo use the functions in this module, you simply upload this to some HTTP server, and call\n\n```elixir\n{:ok, release_map} = fetch_releases_from_url(release_url)\nmaybe_new_release = get_new_version(release_map, current_semver_version_string)\n```\n\nWhich will return either the release map data of a newer release, or `nil` if there is no newer release.","ref":"Burrito.Versions.ReleaseFile.html"},{"type":"function","title":"Burrito.Versions.ReleaseFile.fetch_releases_from_url/2","doc":"","ref":"Burrito.Versions.ReleaseFile.html#fetch_releases_from_url/2"},{"type":"function","title":"Burrito.Versions.ReleaseFile.get_new_version/2","doc":"","ref":"Burrito.Versions.ReleaseFile.html#get_new_version/2"},{"type":"extras","title":"Burrito 🌯","doc":"# Burrito 🌯\n\n[![Hex version badge](https://img.shields.io/hexpm/v/burrito.svg)](https://hex.pm/packages/burrito)","ref":"readme.html"},{"type":"extras","title":"Cross-Platform Elixir Deployments - Burrito 🌯","doc":"* [What Is It?](#what-is-it)\n  * [Background](#background)\n  * [Feature Overview](#feature-overview)\n  * [Technical Component Overview](#technical-component-overview)\n  * [End-To-End Overview](#end-to-end-overview)\n* [Quick Start](#quick-start)\n  * [Experimental Disclaimer](#disclaimer)\n  * [Preparation and Requirements](#preparation-and-requirements)\n  * [Mix Project Setup](#mix-project-setup)\n  * [Mix Release Config Options](#mix-release-config-options)\n  * [Build-Time Environment Variables](#build-time-environment-variables)\n  * [Application Entry Point](#application-entry-point)\n  * [Maintenance Commands](#maintenance-commands)\n* [Advanced Build Configuration](#advanced-build-configuration)\n  * [Build Steps and Phases](#build-steps-and-phases)\n  * [Build Targets and Qualifiers](#build-targets-and-qualifiers)\n  * [Using custom ERTS builds](#using-custom-erts-builds)\n* [Known Limitations and Issues](#known-limitations-and-issues)\n  * [Phoenix Applications](#phx-tips)\n  * [Runtime Requirements](#runtime-requirements)\n* [Contributing](#contributing)\n  * [Welcome!](#welcome)","ref":"readme.html#cross-platform-elixir-deployments"},{"type":"extras","title":"What Is It? - Burrito 🌯","doc":"##","ref":"readme.html#what-is-it"},{"type":"extras","title":"Background - Burrito 🌯","doc":"Burrito is our answer to the problem of distributing Elixir CLI applications across varied environments, where we cannot guarantee that the Erlang runtime is installed, and where we lack the permissions to install it ourselves. In particular, we have CLI tooling that must be deployed on-premise, by consultants, into customer environments that may be running MacOS, Linux, or Windows.\n\nFurthermore, these tools depend on NIFs that we need to cross-compile for any of the environments that we support, from one common build server, running in our CI environment.\n\nWe were heavily inspired by [Bakeware](https://github.com/bake-bake-bake/bakeware), which lays a lot of the ground work for our approach. Ultimately we implemented and expanded upon many of Bakeware's ideas using [Zig](https://ziglang.org/).\n\n##","ref":"readme.html#background"},{"type":"extras","title":"Feature Overview - Burrito 🌯","doc":"* Builds a self-extracting archive for a Mix project, targeting Windows, MacOS, and Linux, containing:\n  * Your compiled BEAM code\n  * The required ERTS for your project\n  * Compilation artifacts for any [elixir-make](https://github.com/elixir-lang/elixir_make) based NIFs used by the project\n* Provides a \"plugin\" interface for injecting Zig code into your application's boot sequence\n  * We use this to perform automatic updates and licensing checks (see `lib/versions/release_file.ex` for details)\n* Automatically uninstalls old versions of the payload if a new version is run.\n\n##","ref":"readme.html#feature-overview"},{"type":"extras","title":"Supported Versions: - Burrito 🌯","doc":"We provide pre-compiled Erlang/OTP distributions starting from `OTP-25.3` onwards for MacOS, Linux, and Windows targets.\nIf you require an older version, please refer to the section about [providing custom Erlang/OTP builds](#using-custom-erts-builds).\n\n##","ref":"readme.html#supported-versions"},{"type":"extras","title":"Technical Component Overview - Burrito 🌯","doc":"Burrito is composed of a few different components:\n* **Mix Release Module** - A module that is executed as a Mix release step. This module takes care of packing up the files, downloading and copying in different Erlang VM Runtime files, and launching the Zig Archiver and Wrapper.\n* **Zig Archiver** - A small Zig library that packs up an entire directory into a tar-like blob. This is known as the \"payload\" -- which will contain all the compiled BEAM code for your release, and the ERTS for the target platform. This is Gzip compressed and then embedded directly into the wrapper program.\n* **Zig Wrapper** - This is portable cross-platform Zig code that wraps around the payload generated during the Mix release process. Erlang is launched in [Embedded Mode](https://www.erlang.org/doc/man/config.html#sys.config) directly from Zig using `execve()` (on Windows we use a child process).\n\n```\n      Burrito Produced Binary\n┌────────────────────────────────┐\n│                                │\n│       Zig Wrapper Binary       │ <---- Compiled from `wrapper.zig`\n│                                │\n├────────────────────────────────┤\n│        Payload Archive         │\n│ ┌────────────────────────────┐ │\n│ │                            │ │\n│ │    ERTS Native Binaries    │ <------ If cross-compiling, this is downloaded from a build server\n│ │                            │ │\n│ └────────────────────────────┘ │\n│                                │ <---- This bottom payload portion is generated by `archiver.zig`\n│ ┌────────────────────────────┐ │\n│ │                            │ │\n│ │   Application BEAM Code    │ │\n│ │                            │ │\n│ └────────────────────────────┘ │\n│                                │\n└────────────────────────────────┘\n```\n\n##","ref":"readme.html#technical-component-overview"},{"type":"extras","title":"End To End Overview - Burrito 🌯","doc":"1. You build a Burrito wrapped binary of your application and send it to an end-user\n 2. The end-user launches your binary like any other native application on their system\n 3. In the background (first-run only) the payload is extracted into a well defined location on the system. (AppData, Application Support, etc.)\n 4. The wrapper executes the Erlang runtime in the background, and transparently launches your application within the same process\n 5. Subsequent runs of the same version of that application will use the previously extracted payload","ref":"readme.html#end-to-end-overview"},{"type":"extras","title":"Quick Start - Burrito 🌯","doc":"##","ref":"readme.html#quick-start"},{"type":"extras","title":"Disclaimer - Burrito 🌯","doc":"Burrito was built with our specific use case in mind, and while we've found success with deploying applications packaged using Burrito to a number of production environments, the approach we're taking is still experimental.\n\nThat being said, we're excited by our early use of the tooling, and are eager to accept community contributions that improve the reliability of Burrito, or that add support for additional platforms.\n\n##","ref":"readme.html#disclaimer"},{"type":"extras","title":"Preparation and Requirements - Burrito 🌯","doc":"**NOTE:** Due to current limitations of Zig, some platforms are less suited as build machines than others: we've found the most success building from Linux and MacOS. The matrix below outlines which build targets are currently supported by each host.\n\n|Target| Host | Host | Host | Host |\n|--|--|--|--|--|\n| | Windows x64 | Linux | MacOS (x86_64) | MacOS (Apple Silicon) |\n| Windows x64 |❌|✅|✅|✅|\n| Linux |❌|✅|✅|✅|\n| MacOS (x86_64) |❌|✅|✅|✅|\n| MacOS (Apple Silicon) |❌|✅|✅|✅|\n\nWe support _targeting_ Windows (x86_64) from MacOS and Linux, we _do not_ officially support building ON Windows, it's recommended you use WSL if your development machine is Windows.\n\n----\n\nYou must have the following installed and in your PATH:\n\n* Zig (0.11.0) -- `zig`\n* XZ -- `xz`\n* 7z -- `7z` (For Windows Targets)\n\n----\n\n##","ref":"readme.html#preparation-and-requirements"},{"type":"extras","title":"Mix Project Setup - Burrito 🌯","doc":"1. Add `burrito` to your list of dependencies:\n\n    ```elixir\n    defp deps do\n      [{:burrito, \"~> 1.0\"}]\n    end\n    ```\n\n2. Create a `releases` function in your `mix.exs`, add and configure the following for your project:\n\n    ```elixir\n    def releases do\n      [\n        example_cli_app: [\n          steps: [:assemble, &Burrito.wrap/1],\n          burrito: [\n            targets: [\n              macos: [os: :darwin, cpu: :x86_64],\n              linux: [os: :linux, cpu: :x86_64],\n              windows: [os: :windows, cpu: :x86_64]\n            ]\n          ]\n        ]\n      ]\n    end\n    ```\n\n(See the [Mix Release Config Options](#mix-release-config-options) for additional options)\n\n3. Add the releases function into your project function:\n   \n  ```elixir\n  def project do\n    [\n      # ... other project configuration\n      releases: releases()\n    ]\n  end\n  ```\n\n4. To build a release for all the targets defined in your `mix.exs` file: `MIX_ENV=prod mix release`\n5. You can also build a single target by setting the `BURRITO_TARGET` environment variable to the alias for that target (e.g. Setting `BURRITO_TARGET=macos` builds only the `macos` target defined above.)\n\nNOTE: In order to speed up iteration times during development, if the Mix environment is not set to `prod`, the binary will always extract its payload, even if that version of the application has already been unpacked on the target machine.\n\n##","ref":"readme.html#mix-project-setup"},{"type":"extras","title":"Mix Release Config Options - Burrito 🌯","doc":"* `targets` - A list of atoms, the targets you want to build for (`:darwin`, `:win64`, `:linux`, `:linux_musl`) whenever you run a `mix release` command -- if not defined, defaults to native host platform only.\n* `debug` - Boolean, will produce a debug build if set to true. (Default: `false`)\n* `no_clean` - Boolean, will not clean up after building if set to true. (Default: `false`)\n* `plugin` - String, a path to a Zig file that contains a function `burrito_plugin_entry()` which will be called before unpacking the payload at runtime. See [the example application for details.](example/test_plugin/plugin.zig)\n\n##","ref":"readme.html#mix-release-config-options"},{"type":"extras","title":"Build-Time Environment Variables - Burrito 🌯","doc":"* `BURRITO_TARGET` - Override the list of targets provided in your release configuration. (ex: `BURRITO_TARGET=win64`, `BURRITO_TARGET=linux,darwin`)\n\n##","ref":"readme.html#build-time-environment-variables"},{"type":"extras","title":"Application Entry Point - Burrito 🌯","doc":"For Burrito to work properly you must define a `:mod` in your project's Mix config:\n```elixir\ndef application do\n  [\n    mod: {MyEntryModule, []}\n  ]\nend\n```\nThis module must implement the callbacks defined by the [`Application`](https://hexdocs.pm/elixir/1.12/Application.html) module, as stated in the Mix documentation:\n\n```elixir\ndefmodule MyEntryModule do\n  def start(_, _) do\n   # Returning `{:ok, pid}` will prevent the application from halting.\n   # Use System.halt(exit_code) to terminate the VM when required\n  end\nend\n```\n\nIf you wish you retrieve the argv passed to your program by Burrito use this snippet:\n\n```elixir\nargs = Burrito.Util.Args.get_arguments() # this returns a list of strings\n```\n\n##","ref":"readme.html#application-entry-point"},{"type":"extras","title":"Maintenance Commands - Burrito 🌯","doc":"Binaries built by Burrito include a built-in set of commands for performing maintenance operations against the included application:\n\n* `./my-binary maintenance uninstall` - Will prompt to uninstall the unpacked payload on the host machine.\n\n* `./my-binary maintenance directory`- Will print the path to the installation directory for the unpacked payload on the host machine.\n\n* `./my-binary maintenance meta` - Will print the metadata for binary.","ref":"readme.html#maintenance-commands"},{"type":"extras","title":"Advanced Build Configuration - Burrito 🌯","doc":"##","ref":"readme.html#advanced-build-configuration"},{"type":"extras","title":"Build Steps and Phases - Burrito 🌯","doc":"Burrito runs the mix release task in three \"Phases\". Each of these phases contains a number of \"Steps\", and a context struct containing the current state of the build, which is passed between each step.\n\nThe three phases of the Burrito build pipeline are:\n\n  * `Fetch` - This phase is responsible for downloading or locally locating any replacement ERTS builds for cross-build targets.\n  * `Patch` - This phase copies replacement ERTS files, and re-compiles NIFs (if any). This phase is also where any custom files should be copied into the build directory before being archived.\n  * `Build` -  This is the final phase in the build flow, it produces the final wrapper binary with the payload embedded inside.\n\n  You can add your own steps before and after phases execute. Your custom steps will also receive the build context struct, and can return a modified one to customize a build to your liking.\n\n  An example of adding a step before the fetch phase, and after the build phase:\n\n  ```elixir\n  # ... mix.exs file\n  def releases do\n    [\n      my_app: [\n        steps: [:assemble, &Burrito.wrap/1],\n        burrito: [\n          # ... other Burrito configuration\n          extra_steps: [\n            fetch: [pre: [MyCustomStepModule, AnotherCustomStepModule]],\n            build: [post: [CustomStepAgain, YetAnotherCustomStepModule]]\n          ]\n        ]\n      ]\n    ]\n  end\n  ```\n\n  You can override default steps or phases by setting the `phases` option.\n\n  If your build phase's requirements are different to Burrito's, specify your own `assemble` step that calls `Burrito.Builder.build(release)`.\n\n  ```elixir\n    # ... mix.exs file\n    def releases do\n      [\n        my_app: [\n          steps: [:assemble, &MyProject.wrap/1],\n          burrito: [\n            # ... other Burrito configuration\n            phases: [\n              build: [MyProject.CustomBuildStep1, MyProject.CustomBuildStep2]\n            ]\n          ]\n        ]\n      ]\n    end\n  ```\n\n  ```elixir\n  defmodule MyProject\n    def wrap(%Mix.Release{} = release) do\n      pre_check(release)\n      Burrito.Builder.build(release)\n    end\n\n    defp pre_check(release) do\n      # checks specific to your build.\n    end\n  end\n  ```\n\n##","ref":"readme.html#build-steps-and-phases"},{"type":"extras","title":"Build Targets and Qualifiers - Burrito 🌯","doc":"A Burrito build target is a keyword list that contains an operating system, a CPU architecture, and extra build options (called Qualifiers).\n\nHere's a definition for a build target configured for Linux x86-64 that adds extra `CFLAGS` to the NIF recompile step:\n\n```elixir\ntargets: [\n  linux: [os: :linux, cpu: :x86_64, nif_cflags: \"-DSOME_DEFINE\"]\n]\n```\n\nBuild qualifiers are a simple way to pass specific flags into the Burrito build pipeline. Here is a list of the supported qualifiers:\n\n* `custom_erts` - `binary()` or `URI.t()` that points to a custom tar.gz. See [Using custom ERTS builds](#using-custom-erts-builds) for more info.\n* `nif_cflags` - `binary()` String that is appended to the end of `CFLAGS` when recompiling NIFs for another target.\n* `nif_cxxflags` - `binary()` String that is appended to the end of `CXXFLAGS` when recompiling NIFs for another target.\n* `nif_env` - `list(tuple())` List of 2-tuples (strings) that define environment variables when recompiling NIFs for another target.\n* `nif_make_args` - `binary()` String that is appended to the `make` call when Elixir make is invoked for recompiling NIFs.\n* `skip_nifs` - `boolean()` Boolean value, defaults to `false`, if set to `true` NIFs will NOT be recompiled. Use this if you want to copy in NIFs that you recompiled yourself in combination with extra/custom build steps. \n\nTip: You can use these qualifiers as a way to pass per-target information into your custom build steps.\n\n##","ref":"readme.html#build-targets-and-qualifiers"},{"type":"extras","title":"Using Custom ERTS Builds - Burrito 🌯","doc":"The Burrito project provides precompiled builds of Erlang for the following platforms:\n\n```elixir\n[os: :darwin, cpu: :x86_64],\n[os: :darwin, cpu: :aarch64],\n[os: :linux, cpu: :x86_64],\n[os: :linux, cpu: :aarch64],\n[os: :windows, cpu: :x86_64]\n```\n\nIf you require a custom build of ERTS, you're able to override the precompiled binaries on a per target basis by setting `custom_erts` to the path of your ERTS build:\n\n```elixir\ntargets: [\n  linux_arm: [\n    os: :linux,\n    cpu: :aarch64,\n    custom_erts: \"/path/to/my_custom_erts.tar.gz\"\n  ]\n]\n```\n\nThe `custom_erts` value should be a path to a local `.tar.gz` of a release from the Erlang source tree. The structure inside the archive should mirror:\n\n```\n. (TAR Root)\n└─ otp-A.B.C-OS-ARCH\n  ├─ erts-X.Y.Z/\n  ├─ releases/\n  ├─ lib/\n  ├─ misc/\n  ├─ usr/\n  └─ Install\n```\n\nYou can easily build an archive like this by doing the following commands inside the (official Erlang source code)[https://github.com/erlang/otp]:\n\n```bash\n# configure and build Erlang as you require...\n# ...\n\nexport RELEASE_ROOT=$(pwd)/release/otp-A.B.C-OS-ARCH\nmake release\ncd release\ntar czf my_custom_erts.tar.gz otp-A.B.C-OS-ARCH\n```","ref":"readme.html#using-custom-erts-builds"},{"type":"extras","title":"Known Limitations and Issues - Burrito 🌯","doc":"##","ref":"readme.html#known-limitations-and-issues"},{"type":"extras","title":"Phx Tips - Burrito 🌯","doc":"In order to run a Phoenix app with Burrito, you may need to edit your `runtime.exs` file to ensure it will always start up the server:\n\n```elixir\n# This is the default line in runtime.exs, you can remove the if statement wrapping this config line, or check for other conditions:\nif System.get_env(\"PHX_SERVER\") do\n  config :phx_app, PhxAppWeb.Endpoint, server: true\nend\n```\n\nIf you do not want to edit `runtime.exs` just ensure the environment variable `PHX_SERVER` is set to `1` when you launch your burrito wrapped binary. Otherwise it will simply exit without starting your server application.\n\nAdditionally, you should take care to ensure you compile your assets BEFORE you wrap your application with Burrito.\n\n##","ref":"readme.html#phx-tips"},{"type":"extras","title":"Runtime Requirements - Burrito 🌯","doc":"Minimizing the runtime dependencies of the package binaries is an explicit design goal, and the requirements for each platform are as follows:\n###","ref":"readme.html#runtime-requirements"},{"type":"extras","title":"Windows - Burrito 🌯","doc":"* MSVC Runtime for the Erlang version you are shipping\n* Windows 10 Build 1511 or later (for ANSI color support)\n###","ref":"readme.html#windows"},{"type":"extras","title":"Linux - Burrito 🌯","doc":"* No runtime dependencies.\n###","ref":"readme.html#linux"},{"type":"extras","title":"MacOS - Burrito 🌯","doc":"* No runtime dependencies. however a security exemption must be set in MacOS Gatekeeper unless the binary undergoes code-signing.","ref":"readme.html#macos"},{"type":"extras","title":"Contributing - Burrito 🌯","doc":"##","ref":"readme.html#contributing"},{"type":"extras","title":"Welcome! - Burrito 🌯","doc":"We are happy to review and accept pull requests to improve Burrito, and ask that you follow the established code formatting present in the repo!\n\nEverything in this repo is licensed under The MIT License, see `LICENSE` for the full license text.","ref":"readme.html#welcome"}],"content_type":"text/markdown"}